//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	$Id: info.h,v 1.1 2002/07/13 08:17:19 dj_jl Exp $
//**
//**	Copyright (C) 1999-2002 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**
//**************************************************************************
//**
//** Info.h
//**
//**************************************************************************

enum
{
    SPR1_TROO,
    SPR1_SHTG,
    SPR1_PUNG,
    SPR1_PISG,
    SPR1_PISF,
    SPR1_SHTF,
    SPR1_SHT2,
    SPR1_CHGG,
    SPR1_CHGF,
    SPR1_MISG,
    SPR1_MISF,
    SPR1_SAWG,
    SPR1_PLSG,
    SPR1_PLSF,
    SPR1_BFGG,
    SPR1_BFGF,
    SPR1_BLUD,
    SPR1_PUFF,
    SPR1_BAL1,
    SPR1_BAL2,
    SPR1_PLSS,
    SPR1_PLSE,
    SPR1_MISL,
    SPR1_BFS1,
    SPR1_BFE1,
    SPR1_BFE2,
    SPR1_TFOG,
    SPR1_IFOG,
    SPR1_PLAY,
    SPR1_POSS,
    SPR1_SPOS,
    SPR1_VILE,
    SPR1_FIRE,
    SPR1_FATB,
    SPR1_FBXP,
    SPR1_SKEL,
    SPR1_MANF,
    SPR1_FATT,
    SPR1_CPOS,
    SPR1_SARG,
    SPR1_HEAD,
    SPR1_BAL7,
    SPR1_BOSS,
    SPR1_BOS2,
    SPR1_SKUL,
    SPR1_SPID,
    SPR1_BSPI,
    SPR1_APLS,
    SPR1_APBX,
    SPR1_CYBR,
    SPR1_PAIN,
    SPR1_SSWV,
    SPR1_KEEN,
    SPR1_BBRN,
    SPR1_BOSF,
    SPR1_ARM1,
    SPR1_ARM2,
    SPR1_BAR1,
    SPR1_BEXP,
    SPR1_FCAN,
    SPR1_BON1,
    SPR1_BON2,
    SPR1_BKEY,
    SPR1_RKEY,
    SPR1_YKEY,
    SPR1_BSKU,
    SPR1_RSKU,
    SPR1_YSKU,
    SPR1_STIM,
    SPR1_MEDI,
    SPR1_SOUL,
    SPR1_PINV,
    SPR1_PSTR,
    SPR1_PINS,
    SPR1_MEGA,
    SPR1_SUIT,
    SPR1_PMAP,
    SPR1_PVIS,
    SPR1_CLIP,
    SPR1_AMMO,
    SPR1_ROCK,
    SPR1_BROK,
    SPR1_CELL,
    SPR1_CELP,
    SPR1_SHEL,
    SPR1_SBOX,
    SPR1_BPAK,
    SPR1_BFUG,
    SPR1_MGUN,
    SPR1_CSAW,
    SPR1_LAUN,
    SPR1_PLAS,
    SPR1_SHOT,
    SPR1_SGN2,
    SPR1_COLU,
    SPR1_SMT2,
    SPR1_GOR1,
    SPR1_POL2,
    SPR1_POL5,
    SPR1_POL4,
    SPR1_POL3,
    SPR1_POL1,
    SPR1_POL6,
    SPR1_GOR2,
    SPR1_GOR3,
    SPR1_GOR4,
    SPR1_GOR5,
    SPR1_SMIT,
    SPR1_COL1,
    SPR1_COL2,
    SPR1_COL3,
    SPR1_COL4,
    SPR1_CAND,
    SPR1_CBRA,
    SPR1_COL6,
    SPR1_TRE1,
    SPR1_TRE2,
    SPR1_ELEC,
    SPR1_CEYE,
    SPR1_FSKU,
    SPR1_COL5,
    SPR1_TBLU,
    SPR1_TGRN,
    SPR1_TRED,
    SPR1_SMBT,
    SPR1_SMGT,
    SPR1_SMRT,
    SPR1_HDB1,
    SPR1_HDB2,
    SPR1_HDB3,
    SPR1_HDB4,
    SPR1_HDB5,
    SPR1_HDB6,
    SPR1_POB1,
    SPR1_POB2,
    SPR1_BRS1,
    SPR1_TLMP,
    SPR1_TLP2,

	NUMSPRITES
};

enum
{
	SA1_NULL,
    SA1_Light0,
    SA1_WeaponReady,
    SA1_Lower,
    SA1_Raise,
    SA1_Punch,
    SA1_ReFire,
    SA1_FirePistol,
	SA1_Light1,
	SA1_FireShotgun,
    SA1_Light2,
    SA1_FireShotgun2,
    SA1_CheckReload,
    SA1_OpenShotgun2,
    SA1_LoadShotgun2,
    SA1_CloseShotgun2,
    SA1_FireCGun,
    SA1_GunFlash,
    SA1_FireMissile,
    SA1_Saw,
    SA1_FirePlasma,
    SA1_BFGsound,
    SA1_FireBFG,
    SA1_BFGSpray,

    SA1_Explode,
    SA1_Pain,
    SA1_PlayerScream,
    SA1_Fall,
    SA1_XScream,
    SA1_Look,
    SA1_Chase,
    SA1_FaceTarget,
    SA1_PosAttack,
    SA1_Scream,
    SA1_SPosAttack,
    SA1_VileChase,
    SA1_VileStart,
    SA1_VileTarget,
    SA1_VileAttack,
    SA1_StartFire,
    SA1_Fire,
    SA1_FireCrackle,
    SA1_Tracer,
    SA1_SkelWhoosh,
    SA1_SkelFist,
    SA1_SkelMissile,
    SA1_FatRaise,
    SA1_FatAttack1,
    SA1_FatAttack2,
    SA1_FatAttack3,
    SA1_BossDeath,
    SA1_CPosAttack,
    SA1_CPosRefire,
    SA1_TroopAttack,
    SA1_SargAttack,
    SA1_HeadAttack,
    SA1_BruisAttack,
    SA1_SkullAttack,
    SA1_Metal,
    SA1_SpidRefire,
    SA1_BabyMetal,
    SA1_BspiAttack,
    SA1_Hoof,
    SA1_CyberAttack,
    SA1_PainAttack,
    SA1_PainDie,
    SA1_KeenDie,
    SA1_BrainPain,
    SA1_BrainScream,
    SA1_BrainDie,
    SA1_BrainAwake,
    SA1_BrainSpit,
    SA1_SpawnSound,
    SA1_SpawnFly,
    SA1_BrainExplode,

	NUM_STATE_ACTIONS
};

enum
{
    S1_NULL,
    S1_LIGHTDONE,
    S1_PUNCH,
    S1_PUNCHDOWN,
    S1_PUNCHUP,
    S1_PUNCH1,
    S1_PUNCH2,
    S1_PUNCH3,
    S1_PUNCH4,
    S1_PUNCH5,
    S1_PISTOL,
    S1_PISTOLDOWN,
    S1_PISTOLUP,
    S1_PISTOL1,
    S1_PISTOL2,
    S1_PISTOL3,
    S1_PISTOL4,
    S1_PISTOLFLASH,
    S1_SGUN,
    S1_SGUNDOWN,
    S1_SGUNUP,
    S1_SGUN1,
    S1_SGUN2,
    S1_SGUN3,
    S1_SGUN4,
    S1_SGUN5,
    S1_SGUN6,
    S1_SGUN7,
    S1_SGUN8,
    S1_SGUN9,
    S1_SGUNFLASH1,
    S1_SGUNFLASH2,
    S1_DSGUN,
    S1_DSGUNDOWN,
    S1_DSGUNUP,
    S1_DSGUN1,
    S1_DSGUN2,
    S1_DSGUN3,
    S1_DSGUN4,
    S1_DSGUN5,
    S1_DSGUN6,
    S1_DSGUN7,
    S1_DSGUN8,
    S1_DSGUN9,
    S1_DSGUN10,
    S1_DSNR1,
    S1_DSNR2,
    S1_DSGUNFLASH1,
    S1_DSGUNFLASH2,
    S1_CHAIN,
    S1_CHAINDOWN,
    S1_CHAINUP,
    S1_CHAIN1,
    S1_CHAIN2,
    S1_CHAIN3,
    S1_CHAINFLASH1,
    S1_CHAINFLASH2,
    S1_MISSILE,
    S1_MISSILEDOWN,
    S1_MISSILEUP,
    S1_MISSILE1,
    S1_MISSILE2,
    S1_MISSILE3,
    S1_MISSILEFLASH1,
    S1_MISSILEFLASH2,
    S1_MISSILEFLASH3,
    S1_MISSILEFLASH4,
    S1_SAW,
    S1_SAWB,
    S1_SAWDOWN,
    S1_SAWUP,
    S1_SAW1,
    S1_SAW2,
    S1_SAW3,
    S1_PLASMA,
    S1_PLASMADOWN,
    S1_PLASMAUP,
    S1_PLASMA1,
    S1_PLASMA2,
    S1_PLASMAFLASH1,
    S1_PLASMAFLASH2,
    S1_BFG,
    S1_BFGDOWN,
    S1_BFGUP,
    S1_BFG1,
    S1_BFG2,
    S1_BFG3,
    S1_BFG4,
    S1_BFGFLASH1,
    S1_BFGFLASH2,
    S1_BLOOD1,
    S1_BLOOD2,
    S1_BLOOD3,
    S1_PUFF1,
    S1_PUFF2,
    S1_PUFF3,
    S1_PUFF4,
    S1_TBALL1,
    S1_TBALL2,
    S1_TBALLX1,
    S1_TBALLX2,
    S1_TBALLX3,
    S1_RBALL1,
    S1_RBALL2,
    S1_RBALLX1,
    S1_RBALLX2,
    S1_RBALLX3,
    S1_PLASBALL,
    S1_PLASBALL2,
    S1_PLASEXP,
    S1_PLASEXP2,
    S1_PLASEXP3,
    S1_PLASEXP4,
    S1_PLASEXP5,
    S1_ROCKET,
    S1_BFGSHOT,
    S1_BFGSHOT2,
    S1_BFGLAND,
    S1_BFGLAND2,
    S1_BFGLAND3,
    S1_BFGLAND4,
    S1_BFGLAND5,
    S1_BFGLAND6,
    S1_BFGEXP,
    S1_BFGEXP2,
    S1_BFGEXP3,
    S1_BFGEXP4,
    S1_EXPLODE1,
    S1_EXPLODE2,
    S1_EXPLODE3,
    S1_TFOG,
    S1_TFOG01,
    S1_TFOG02,
    S1_TFOG2,
    S1_TFOG3,
    S1_TFOG4,
    S1_TFOG5,
    S1_TFOG6,
    S1_TFOG7,
    S1_TFOG8,
    S1_TFOG9,
    S1_TFOG10,
    S1_IFOG,
    S1_IFOG01,
    S1_IFOG02,
    S1_IFOG2,
    S1_IFOG3,
    S1_IFOG4,
    S1_IFOG5,
    S1_PLAY,
    S1_PLAY_RUN1,
    S1_PLAY_RUN2,
    S1_PLAY_RUN3,
    S1_PLAY_RUN4,
    S1_PLAY_ATK1,
    S1_PLAY_ATK2,
    S1_PLAY_PAIN,
    S1_PLAY_PAIN2,
    S1_PLAY_DIE1,
    S1_PLAY_DIE2,
    S1_PLAY_DIE3,
    S1_PLAY_DIE4,
    S1_PLAY_DIE5,
    S1_PLAY_DIE6,
    S1_PLAY_DIE7,
    S1_PLAY_XDIE1,
    S1_PLAY_XDIE2,
    S1_PLAY_XDIE3,
    S1_PLAY_XDIE4,
    S1_PLAY_XDIE5,
    S1_PLAY_XDIE6,
    S1_PLAY_XDIE7,
    S1_PLAY_XDIE8,
    S1_PLAY_XDIE9,
    S1_POSS_STND,
    S1_POSS_STND2,
    S1_POSS_RUN1,
    S1_POSS_RUN2,
    S1_POSS_RUN3,
    S1_POSS_RUN4,
    S1_POSS_RUN5,
    S1_POSS_RUN6,
    S1_POSS_RUN7,
    S1_POSS_RUN8,
    S1_POSS_ATK1,
    S1_POSS_ATK2,
    S1_POSS_ATK3,
    S1_POSS_PAIN,
    S1_POSS_PAIN2,
    S1_POSS_DIE1,
    S1_POSS_DIE2,
    S1_POSS_DIE3,
    S1_POSS_DIE4,
    S1_POSS_DIE5,
    S1_POSS_XDIE1,
    S1_POSS_XDIE2,
    S1_POSS_XDIE3,
    S1_POSS_XDIE4,
    S1_POSS_XDIE5,
    S1_POSS_XDIE6,
    S1_POSS_XDIE7,
    S1_POSS_XDIE8,
    S1_POSS_XDIE9,
    S1_POSS_RAISE1,
    S1_POSS_RAISE2,
    S1_POSS_RAISE3,
    S1_POSS_RAISE4,
    S1_SPOS_STND,
    S1_SPOS_STND2,
    S1_SPOS_RUN1,
    S1_SPOS_RUN2,
    S1_SPOS_RUN3,
    S1_SPOS_RUN4,
    S1_SPOS_RUN5,
    S1_SPOS_RUN6,
    S1_SPOS_RUN7,
    S1_SPOS_RUN8,
    S1_SPOS_ATK1,
    S1_SPOS_ATK2,
    S1_SPOS_ATK3,
    S1_SPOS_PAIN,
    S1_SPOS_PAIN2,
    S1_SPOS_DIE1,
    S1_SPOS_DIE2,
    S1_SPOS_DIE3,
    S1_SPOS_DIE4,
    S1_SPOS_DIE5,
    S1_SPOS_XDIE1,
    S1_SPOS_XDIE2,
    S1_SPOS_XDIE3,
    S1_SPOS_XDIE4,
    S1_SPOS_XDIE5,
    S1_SPOS_XDIE6,
    S1_SPOS_XDIE7,
    S1_SPOS_XDIE8,
    S1_SPOS_XDIE9,
    S1_SPOS_RAISE1,
    S1_SPOS_RAISE2,
    S1_SPOS_RAISE3,
    S1_SPOS_RAISE4,
    S1_SPOS_RAISE5,
    S1_VILE_STND,
    S1_VILE_STND2,
    S1_VILE_RUN1,
    S1_VILE_RUN2,
    S1_VILE_RUN3,
    S1_VILE_RUN4,
    S1_VILE_RUN5,
    S1_VILE_RUN6,
    S1_VILE_RUN7,
    S1_VILE_RUN8,
    S1_VILE_RUN9,
    S1_VILE_RUN10,
    S1_VILE_RUN11,
    S1_VILE_RUN12,
    S1_VILE_ATK1,
    S1_VILE_ATK2,
    S1_VILE_ATK3,
    S1_VILE_ATK4,
    S1_VILE_ATK5,
    S1_VILE_ATK6,
    S1_VILE_ATK7,
    S1_VILE_ATK8,
    S1_VILE_ATK9,
    S1_VILE_ATK10,
    S1_VILE_ATK11,
    S1_VILE_HEAL1,
    S1_VILE_HEAL2,
    S1_VILE_HEAL3,
    S1_VILE_PAIN,
    S1_VILE_PAIN2,
    S1_VILE_DIE1,
    S1_VILE_DIE2,
    S1_VILE_DIE3,
    S1_VILE_DIE4,
    S1_VILE_DIE5,
    S1_VILE_DIE6,
    S1_VILE_DIE7,
    S1_VILE_DIE8,
    S1_VILE_DIE9,
    S1_VILE_DIE10,
    S1_FIRE1,
    S1_FIRE2,
    S1_FIRE3,
    S1_FIRE4,
    S1_FIRE5,
    S1_FIRE6,
    S1_FIRE7,
    S1_FIRE8,
    S1_FIRE9,
    S1_FIRE10,
    S1_FIRE11,
    S1_FIRE12,
    S1_FIRE13,
    S1_FIRE14,
    S1_FIRE15,
    S1_FIRE16,
    S1_FIRE17,
    S1_FIRE18,
    S1_FIRE19,
    S1_FIRE20,
    S1_FIRE21,
    S1_FIRE22,
    S1_FIRE23,
    S1_FIRE24,
    S1_FIRE25,
    S1_FIRE26,
    S1_FIRE27,
    S1_FIRE28,
    S1_FIRE29,
    S1_FIRE30,
    S1_SMOKE1,
    S1_SMOKE2,
    S1_SMOKE3,
    S1_SMOKE4,
    S1_SMOKE5,
    S1_TRACER,
    S1_TRACER2,
    S1_TRACEEXP1,
    S1_TRACEEXP2,
    S1_TRACEEXP3,
    S1_SKEL_STND,
    S1_SKEL_STND2,
    S1_SKEL_RUN1,
    S1_SKEL_RUN2,
    S1_SKEL_RUN3,
    S1_SKEL_RUN4,
    S1_SKEL_RUN5,
    S1_SKEL_RUN6,
    S1_SKEL_RUN7,
    S1_SKEL_RUN8,
    S1_SKEL_RUN9,
    S1_SKEL_RUN10,
    S1_SKEL_RUN11,
    S1_SKEL_RUN12,
    S1_SKEL_FIST1,
    S1_SKEL_FIST2,
    S1_SKEL_FIST3,
    S1_SKEL_FIST4,
    S1_SKEL_MISS1,
    S1_SKEL_MISS2,
    S1_SKEL_MISS3,
    S1_SKEL_MISS4,
    S1_SKEL_PAIN,
    S1_SKEL_PAIN2,
    S1_SKEL_DIE1,
    S1_SKEL_DIE2,
    S1_SKEL_DIE3,
    S1_SKEL_DIE4,
    S1_SKEL_DIE5,
    S1_SKEL_DIE6,
    S1_SKEL_RAISE1,
    S1_SKEL_RAISE2,
    S1_SKEL_RAISE3,
    S1_SKEL_RAISE4,
    S1_SKEL_RAISE5,
    S1_SKEL_RAISE6,
    S1_FATSHOT1,
    S1_FATSHOT2,
    S1_FATSHOTX1,
    S1_FATSHOTX2,
    S1_FATSHOTX3,
    S1_FATT_STND,
    S1_FATT_STND2,
    S1_FATT_RUN1,
    S1_FATT_RUN2,
    S1_FATT_RUN3,
    S1_FATT_RUN4,
    S1_FATT_RUN5,
    S1_FATT_RUN6,
    S1_FATT_RUN7,
    S1_FATT_RUN8,
    S1_FATT_RUN9,
    S1_FATT_RUN10,
    S1_FATT_RUN11,
    S1_FATT_RUN12,
    S1_FATT_ATK1,
    S1_FATT_ATK2,
    S1_FATT_ATK3,
    S1_FATT_ATK4,
    S1_FATT_ATK5,
    S1_FATT_ATK6,
    S1_FATT_ATK7,
    S1_FATT_ATK8,
    S1_FATT_ATK9,
    S1_FATT_ATK10,
    S1_FATT_PAIN,
    S1_FATT_PAIN2,
    S1_FATT_DIE1,
    S1_FATT_DIE2,
    S1_FATT_DIE3,
    S1_FATT_DIE4,
    S1_FATT_DIE5,
    S1_FATT_DIE6,
    S1_FATT_DIE7,
    S1_FATT_DIE8,
    S1_FATT_DIE9,
    S1_FATT_DIE10,
    S1_FATT_RAISE1,
    S1_FATT_RAISE2,
    S1_FATT_RAISE3,
    S1_FATT_RAISE4,
    S1_FATT_RAISE5,
    S1_FATT_RAISE6,
    S1_FATT_RAISE7,
    S1_FATT_RAISE8,
    S1_CPOS_STND,
    S1_CPOS_STND2,
    S1_CPOS_RUN1,
    S1_CPOS_RUN2,
    S1_CPOS_RUN3,
    S1_CPOS_RUN4,
    S1_CPOS_RUN5,
    S1_CPOS_RUN6,
    S1_CPOS_RUN7,
    S1_CPOS_RUN8,
    S1_CPOS_ATK1,
    S1_CPOS_ATK2,
    S1_CPOS_ATK3,
    S1_CPOS_ATK4,
    S1_CPOS_PAIN,
    S1_CPOS_PAIN2,
    S1_CPOS_DIE1,
    S1_CPOS_DIE2,
    S1_CPOS_DIE3,
    S1_CPOS_DIE4,
    S1_CPOS_DIE5,
    S1_CPOS_DIE6,
    S1_CPOS_DIE7,
    S1_CPOS_XDIE1,
    S1_CPOS_XDIE2,
    S1_CPOS_XDIE3,
    S1_CPOS_XDIE4,
    S1_CPOS_XDIE5,
    S1_CPOS_XDIE6,
    S1_CPOS_RAISE1,
    S1_CPOS_RAISE2,
    S1_CPOS_RAISE3,
    S1_CPOS_RAISE4,
    S1_CPOS_RAISE5,
    S1_CPOS_RAISE6,
    S1_CPOS_RAISE7,
    S1_TROO_STND,
    S1_TROO_STND2,
    S1_TROO_RUN1,
    S1_TROO_RUN2,
    S1_TROO_RUN3,
    S1_TROO_RUN4,
    S1_TROO_RUN5,
    S1_TROO_RUN6,
    S1_TROO_RUN7,
    S1_TROO_RUN8,
    S1_TROO_ATK1,
    S1_TROO_ATK2,
    S1_TROO_ATK3,
    S1_TROO_PAIN,
    S1_TROO_PAIN2,
    S1_TROO_DIE1,
    S1_TROO_DIE2,
    S1_TROO_DIE3,
    S1_TROO_DIE4,
    S1_TROO_DIE5,
    S1_TROO_XDIE1,
    S1_TROO_XDIE2,
    S1_TROO_XDIE3,
    S1_TROO_XDIE4,
    S1_TROO_XDIE5,
    S1_TROO_XDIE6,
    S1_TROO_XDIE7,
    S1_TROO_XDIE8,
    S1_TROO_RAISE1,
    S1_TROO_RAISE2,
    S1_TROO_RAISE3,
    S1_TROO_RAISE4,
    S1_TROO_RAISE5,
    S1_SARG_STND,
    S1_SARG_STND2,
    S1_SARG_RUN1,
    S1_SARG_RUN2,
    S1_SARG_RUN3,
    S1_SARG_RUN4,
    S1_SARG_RUN5,
    S1_SARG_RUN6,
    S1_SARG_RUN7,
    S1_SARG_RUN8,
    S1_SARG_ATK1,
    S1_SARG_ATK2,
    S1_SARG_ATK3,
    S1_SARG_PAIN,
    S1_SARG_PAIN2,
    S1_SARG_DIE1,
    S1_SARG_DIE2,
    S1_SARG_DIE3,
    S1_SARG_DIE4,
    S1_SARG_DIE5,
    S1_SARG_DIE6,
    S1_SARG_RAISE1,
    S1_SARG_RAISE2,
    S1_SARG_RAISE3,
    S1_SARG_RAISE4,
    S1_SARG_RAISE5,
    S1_SARG_RAISE6,
    S1_HEAD_STND,
    S1_HEAD_RUN1,
    S1_HEAD_ATK1,
    S1_HEAD_ATK2,
    S1_HEAD_ATK3,
    S1_HEAD_PAIN,
    S1_HEAD_PAIN2,
    S1_HEAD_PAIN3,
    S1_HEAD_DIE1,
    S1_HEAD_DIE2,
    S1_HEAD_DIE3,
    S1_HEAD_DIE4,
    S1_HEAD_DIE5,
    S1_HEAD_DIE6,
    S1_HEAD_RAISE1,
    S1_HEAD_RAISE2,
    S1_HEAD_RAISE3,
    S1_HEAD_RAISE4,
    S1_HEAD_RAISE5,
    S1_HEAD_RAISE6,
    S1_BRBALL1,
    S1_BRBALL2,
    S1_BRBALLX1,
    S1_BRBALLX2,
    S1_BRBALLX3,
    S1_BOSS_STND,
    S1_BOSS_STND2,
    S1_BOSS_RUN1,
    S1_BOSS_RUN2,
    S1_BOSS_RUN3,
    S1_BOSS_RUN4,
    S1_BOSS_RUN5,
    S1_BOSS_RUN6,
    S1_BOSS_RUN7,
    S1_BOSS_RUN8,
    S1_BOSS_ATK1,
    S1_BOSS_ATK2,
    S1_BOSS_ATK3,
    S1_BOSS_PAIN,
    S1_BOSS_PAIN2,
    S1_BOSS_DIE1,
    S1_BOSS_DIE2,
    S1_BOSS_DIE3,
    S1_BOSS_DIE4,
    S1_BOSS_DIE5,
    S1_BOSS_DIE6,
    S1_BOSS_DIE7,
    S1_BOSS_RAISE1,
    S1_BOSS_RAISE2,
    S1_BOSS_RAISE3,
    S1_BOSS_RAISE4,
    S1_BOSS_RAISE5,
    S1_BOSS_RAISE6,
    S1_BOSS_RAISE7,
    S1_BOS2_STND,
    S1_BOS2_STND2,
    S1_BOS2_RUN1,
    S1_BOS2_RUN2,
    S1_BOS2_RUN3,
    S1_BOS2_RUN4,
    S1_BOS2_RUN5,
    S1_BOS2_RUN6,
    S1_BOS2_RUN7,
    S1_BOS2_RUN8,
    S1_BOS2_ATK1,
    S1_BOS2_ATK2,
    S1_BOS2_ATK3,
    S1_BOS2_PAIN,
    S1_BOS2_PAIN2,
    S1_BOS2_DIE1,
    S1_BOS2_DIE2,
    S1_BOS2_DIE3,
    S1_BOS2_DIE4,
    S1_BOS2_DIE5,
    S1_BOS2_DIE6,
    S1_BOS2_DIE7,
    S1_BOS2_RAISE1,
    S1_BOS2_RAISE2,
    S1_BOS2_RAISE3,
    S1_BOS2_RAISE4,
    S1_BOS2_RAISE5,
    S1_BOS2_RAISE6,
    S1_BOS2_RAISE7,
    S1_SKULL_STND,
    S1_SKULL_STND2,
    S1_SKULL_RUN1,
    S1_SKULL_RUN2,
    S1_SKULL_ATK1,
    S1_SKULL_ATK2,
    S1_SKULL_ATK3,
    S1_SKULL_ATK4,
    S1_SKULL_PAIN,
    S1_SKULL_PAIN2,
    S1_SKULL_DIE1,
    S1_SKULL_DIE2,
    S1_SKULL_DIE3,
    S1_SKULL_DIE4,
    S1_SKULL_DIE5,
    S1_SKULL_DIE6,
    S1_SPID_STND,
    S1_SPID_STND2,
    S1_SPID_RUN1,
    S1_SPID_RUN2,
    S1_SPID_RUN3,
    S1_SPID_RUN4,
    S1_SPID_RUN5,
    S1_SPID_RUN6,
    S1_SPID_RUN7,
    S1_SPID_RUN8,
    S1_SPID_RUN9,
    S1_SPID_RUN10,
    S1_SPID_RUN11,
    S1_SPID_RUN12,
    S1_SPID_ATK1,
    S1_SPID_ATK2,
    S1_SPID_ATK3,
    S1_SPID_ATK4,
    S1_SPID_PAIN,
    S1_SPID_PAIN2,
    S1_SPID_DIE1,
    S1_SPID_DIE2,
    S1_SPID_DIE3,
    S1_SPID_DIE4,
    S1_SPID_DIE5,
    S1_SPID_DIE6,
    S1_SPID_DIE7,
    S1_SPID_DIE8,
    S1_SPID_DIE9,
    S1_SPID_DIE10,
    S1_SPID_DIE11,
    S1_BSPI_STND,
    S1_BSPI_STND2,
    S1_BSPI_SIGHT,
    S1_BSPI_RUN1,
    S1_BSPI_RUN2,
    S1_BSPI_RUN3,
    S1_BSPI_RUN4,
    S1_BSPI_RUN5,
    S1_BSPI_RUN6,
    S1_BSPI_RUN7,
    S1_BSPI_RUN8,
    S1_BSPI_RUN9,
    S1_BSPI_RUN10,
    S1_BSPI_RUN11,
    S1_BSPI_RUN12,
    S1_BSPI_ATK1,
    S1_BSPI_ATK2,
    S1_BSPI_ATK3,
    S1_BSPI_ATK4,
    S1_BSPI_PAIN,
    S1_BSPI_PAIN2,
    S1_BSPI_DIE1,
    S1_BSPI_DIE2,
    S1_BSPI_DIE3,
    S1_BSPI_DIE4,
    S1_BSPI_DIE5,
    S1_BSPI_DIE6,
    S1_BSPI_DIE7,
    S1_BSPI_RAISE1,
    S1_BSPI_RAISE2,
    S1_BSPI_RAISE3,
    S1_BSPI_RAISE4,
    S1_BSPI_RAISE5,
    S1_BSPI_RAISE6,
    S1_BSPI_RAISE7,
    S1_ARACH_PLAZ,
    S1_ARACH_PLAZ2,
    S1_ARACH_PLEX,
    S1_ARACH_PLEX2,
    S1_ARACH_PLEX3,
    S1_ARACH_PLEX4,
    S1_ARACH_PLEX5,
    S1_CYBER_STND,
    S1_CYBER_STND2,
    S1_CYBER_RUN1,
    S1_CYBER_RUN2,
    S1_CYBER_RUN3,
    S1_CYBER_RUN4,
    S1_CYBER_RUN5,
    S1_CYBER_RUN6,
    S1_CYBER_RUN7,
    S1_CYBER_RUN8,
    S1_CYBER_ATK1,
    S1_CYBER_ATK2,
    S1_CYBER_ATK3,
    S1_CYBER_ATK4,
    S1_CYBER_ATK5,
    S1_CYBER_ATK6,
    S1_CYBER_PAIN,
    S1_CYBER_DIE1,
    S1_CYBER_DIE2,
    S1_CYBER_DIE3,
    S1_CYBER_DIE4,
    S1_CYBER_DIE5,
    S1_CYBER_DIE6,
    S1_CYBER_DIE7,
    S1_CYBER_DIE8,
    S1_CYBER_DIE9,
    S1_CYBER_DIE10,
    S1_PAIN_STND,
    S1_PAIN_RUN1,
    S1_PAIN_RUN2,
    S1_PAIN_RUN3,
    S1_PAIN_RUN4,
    S1_PAIN_RUN5,
    S1_PAIN_RUN6,
    S1_PAIN_ATK1,
    S1_PAIN_ATK2,
    S1_PAIN_ATK3,
    S1_PAIN_ATK4,
    S1_PAIN_PAIN,
    S1_PAIN_PAIN2,
    S1_PAIN_DIE1,
    S1_PAIN_DIE2,
    S1_PAIN_DIE3,
    S1_PAIN_DIE4,
    S1_PAIN_DIE5,
    S1_PAIN_DIE6,
    S1_PAIN_RAISE1,
    S1_PAIN_RAISE2,
    S1_PAIN_RAISE3,
    S1_PAIN_RAISE4,
    S1_PAIN_RAISE5,
    S1_PAIN_RAISE6,
    S1_SSWV_STND,
    S1_SSWV_STND2,
    S1_SSWV_RUN1,
    S1_SSWV_RUN2,
    S1_SSWV_RUN3,
    S1_SSWV_RUN4,
    S1_SSWV_RUN5,
    S1_SSWV_RUN6,
    S1_SSWV_RUN7,
    S1_SSWV_RUN8,
    S1_SSWV_ATK1,
    S1_SSWV_ATK2,
    S1_SSWV_ATK3,
    S1_SSWV_ATK4,
    S1_SSWV_ATK5,
    S1_SSWV_ATK6,
    S1_SSWV_PAIN,
    S1_SSWV_PAIN2,
    S1_SSWV_DIE1,
    S1_SSWV_DIE2,
    S1_SSWV_DIE3,
    S1_SSWV_DIE4,
    S1_SSWV_DIE5,
    S1_SSWV_XDIE1,
    S1_SSWV_XDIE2,
    S1_SSWV_XDIE3,
    S1_SSWV_XDIE4,
    S1_SSWV_XDIE5,
    S1_SSWV_XDIE6,
    S1_SSWV_XDIE7,
    S1_SSWV_XDIE8,
    S1_SSWV_XDIE9,
    S1_SSWV_RAISE1,
    S1_SSWV_RAISE2,
    S1_SSWV_RAISE3,
    S1_SSWV_RAISE4,
    S1_SSWV_RAISE5,
    S1_KEENSTND,
    S1_COMMKEEN,
    S1_COMMKEEN2,
    S1_COMMKEEN3,
    S1_COMMKEEN4,
    S1_COMMKEEN5,
    S1_COMMKEEN6,
    S1_COMMKEEN7,
    S1_COMMKEEN8,
    S1_COMMKEEN9,
    S1_COMMKEEN10,
    S1_COMMKEEN11,
    S1_COMMKEEN12,
    S1_KEENPAIN,
    S1_KEENPAIN2,
    S1_BRAIN,
    S1_BRAIN_PAIN,
    S1_BRAIN_DIE1,
    S1_BRAIN_DIE2,
    S1_BRAIN_DIE3,
    S1_BRAIN_DIE4,
    S1_BRAINEYE,
    S1_BRAINEYESEE,
    S1_BRAINEYE1,
    S1_SPAWN1,
    S1_SPAWN2,
    S1_SPAWN3,
    S1_SPAWN4,
    S1_SPAWNFIRE1,
    S1_SPAWNFIRE2,
    S1_SPAWNFIRE3,
    S1_SPAWNFIRE4,
    S1_SPAWNFIRE5,
    S1_SPAWNFIRE6,
    S1_SPAWNFIRE7,
    S1_SPAWNFIRE8,
    S1_BRAINEXPLODE1,
    S1_BRAINEXPLODE2,
    S1_BRAINEXPLODE3,
    S1_ARM1,
    S1_ARM1A,
    S1_ARM2,
    S1_ARM2A,
    S1_BAR1,
    S1_BAR2,
    S1_BEXP,
    S1_BEXP2,
    S1_BEXP3,
    S1_BEXP4,
    S1_BEXP5,
    S1_BBAR1,
    S1_BBAR2,
    S1_BBAR3,
    S1_BON1,
    S1_BON1A,
    S1_BON1B,
    S1_BON1C,
    S1_BON1D,
    S1_BON1E,
    S1_BON2,
    S1_BON2A,
    S1_BON2B,
    S1_BON2C,
    S1_BON2D,
    S1_BON2E,
    S1_BKEY,
    S1_BKEY2,
    S1_RKEY,
    S1_RKEY2,
    S1_YKEY,
    S1_YKEY2,
    S1_BSKULL,
    S1_BSKULL2,
    S1_RSKULL,
    S1_RSKULL2,
    S1_YSKULL,
    S1_YSKULL2,
    S1_STIM,
    S1_MEDI,
    S1_SOUL,
    S1_SOUL2,
    S1_SOUL3,
    S1_SOUL4,
    S1_SOUL5,
    S1_SOUL6,
    S1_PINV,
    S1_PINV2,
    S1_PINV3,
    S1_PINV4,
    S1_PSTR,
    S1_PINS,
    S1_PINS2,
    S1_PINS3,
    S1_PINS4,
    S1_MEGA,
    S1_MEGA2,
    S1_MEGA3,
    S1_MEGA4,
    S1_SUIT,
    S1_PMAP,
    S1_PMAP2,
    S1_PMAP3,
    S1_PMAP4,
    S1_PMAP5,
    S1_PMAP6,
    S1_PVIS,
    S1_PVIS2,
    S1_CLIP,
    S1_AMMO,
    S1_ROCK,
    S1_BROK,
    S1_CELL,
    S1_CELP,
    S1_SHEL,
    S1_SBOX,
    S1_BPAK,
    S1_BFUG,
    S1_MGUN,
    S1_CSAW,
    S1_LAUN,
    S1_PLAS,
    S1_SHOT,
    S1_SHOT2,
    S1_COLU,
    S1_STALAG,
    S1_BLOODYTWITCH,
    S1_BLOODYTWITCH2,
    S1_BLOODYTWITCH3,
    S1_BLOODYTWITCH4,
    S1_DEADTORSO,
    S1_DEADBOTTOM,
    S1_HEADSONSTICK,
    S1_GIBS,
    S1_HEADONASTICK,
    S1_HEADCANDLES,
    S1_HEADCANDLES2,
    S1_DEADSTICK,
    S1_LIVESTICK,
    S1_LIVESTICK2,
    S1_MEAT2,
    S1_MEAT3,
    S1_MEAT4,
    S1_MEAT5,
    S1_STALAGTITE,
    S1_TALLGRNCOL,
    S1_SHRTGRNCOL,
    S1_TALLREDCOL,
    S1_SHRTREDCOL,
    S1_CANDLESTIK,
    S1_CANDELABRA,
    S1_SKULLCOL,
    S1_TORCHTREE,
    S1_BIGTREE,
    S1_TECHPILLAR,
    S1_EVILEYE,
    S1_EVILEYE2,
    S1_EVILEYE3,
    S1_EVILEYE4,
    S1_FLOATSKULL,
    S1_FLOATSKULL2,
    S1_FLOATSKULL3,
    S1_HEARTCOL,
    S1_HEARTCOL2,
    S1_BLUETORCH,
    S1_BLUETORCH2,
    S1_BLUETORCH3,
    S1_BLUETORCH4,
    S1_GREENTORCH,
    S1_GREENTORCH2,
    S1_GREENTORCH3,
    S1_GREENTORCH4,
    S1_REDTORCH,
    S1_REDTORCH2,
    S1_REDTORCH3,
    S1_REDTORCH4,
    S1_BTORCHSHRT,
    S1_BTORCHSHRT2,
    S1_BTORCHSHRT3,
    S1_BTORCHSHRT4,
    S1_GTORCHSHRT,
    S1_GTORCHSHRT2,
    S1_GTORCHSHRT3,
    S1_GTORCHSHRT4,
    S1_RTORCHSHRT,
    S1_RTORCHSHRT2,
    S1_RTORCHSHRT3,
    S1_RTORCHSHRT4,
    S1_HANGNOGUTS,
    S1_HANGBNOBRAIN,
    S1_HANGTLOOKDN,
    S1_HANGTSKULL,
    S1_HANGTLOOKUP,
    S1_HANGTNOBRAIN,
    S1_COLONGIBS,
    S1_SMALLPOOL,
    S1_BRAINSTEM,
    S1_TECHLAMP,
    S1_TECHLAMP2,
    S1_TECHLAMP3,
    S1_TECHLAMP4,
    S1_TECH2LAMP,
    S1_TECH2LAMP2,
    S1_TECH2LAMP3,
    S1_TECH2LAMP4,

	NUMSTATES
};

enum
{
    MT1_PLAYER,
    MT1_POSSESSED,
    MT1_SHOTGUY,
    MT1_VILE,
    MT1_FIRE,
    MT1_UNDEAD,
    MT1_TRACER,
    MT1_SMOKE,
    MT1_FATSO,
    MT1_FATSHOT,
    MT1_CHAINGUY,
    MT1_TROOP,
    MT1_SERGEANT,
    MT1_SHADOWS,
    MT1_HEAD,
    MT1_BRUISER,
    MT1_BRUISERSHOT,
    MT1_KNIGHT,
    MT1_SKULL,
    MT1_SPIDER,
    MT1_BABY,
    MT1_CYBORG,
    MT1_PAIN,
    MT1_WOLFSS,
    MT1_KEEN,
    MT1_BOSSBRAIN,
    MT1_BOSSSPIT,
    MT1_BOSSTARGET,
    MT1_SPAWNSHOT,
    MT1_SPAWNFIRE,
    MT1_BARREL,
    MT1_TROOPSHOT,
    MT1_HEADSHOT,
    MT1_ROCKET,
    MT1_PLASMA,
    MT1_BFG,
    MT1_ARACHPLAZ,
    MT1_PUFF,
    MT1_BLOOD,
    MT1_TFOG,
    MT1_IFOG,
    MT1_TELEPORTMAN,
    MT1_EXTRABFG,
    MT1_MISC0,
    MT1_MISC1,
    MT1_MISC2,
    MT1_MISC3,
    MT1_MISC4,
    MT1_MISC5,
    MT1_MISC6,
    MT1_MISC7,
    MT1_MISC8,
    MT1_MISC9,
    MT1_MISC10,
    MT1_MISC11,
    MT1_MISC12,
    MT1_INV,
    MT1_MISC13,
    MT1_INS,
    MT1_MISC14,
    MT1_MISC15,
    MT1_MISC16,
    MT1_MEGA,
    MT1_CLIP,
    MT1_MISC17,
    MT1_MISC18,
    MT1_MISC19,
    MT1_MISC20,
    MT1_MISC21,
    MT1_MISC22,
    MT1_MISC23,
    MT1_MISC24,
    MT1_MISC25,
    MT1_CHAINGUN,
    MT1_MISC26,
    MT1_MISC27,
    MT1_MISC28,
    MT1_SHOTGUN,
    MT1_SUPERSHOTGUN,
    MT1_MISC29,
    MT1_MISC30,
    MT1_MISC31,
    MT1_MISC32,
    MT1_MISC33,
    MT1_MISC34,
    MT1_MISC35,
    MT1_MISC36,
    MT1_MISC37,
    MT1_MISC38,
    MT1_MISC39,
    MT1_MISC40,
    MT1_MISC41,
    MT1_MISC42,
    MT1_MISC43,
    MT1_MISC44,
    MT1_MISC45,
    MT1_MISC46,
    MT1_MISC47,
    MT1_MISC48,
    MT1_MISC49,
    MT1_MISC50,
    MT1_MISC51,
    MT1_MISC52,
    MT1_MISC53,
    MT1_MISC54,
    MT1_MISC55,
    MT1_MISC56,
    MT1_MISC57,
    MT1_MISC58,
    MT1_MISC59,
    MT1_MISC60,
    MT1_MISC61,
    MT1_MISC62,
    MT1_MISC63,
    MT1_MISC64,
    MT1_MISC65,
    MT1_MISC66,
    MT1_MISC67,
    MT1_MISC68,
    MT1_MISC69,
    MT1_MISC70,
    MT1_MISC71,
    MT1_MISC72,
    MT1_MISC73,
    MT1_MISC74,
    MT1_MISC75,
    MT1_MISC76,
    MT1_MISC77,
    MT1_MISC78,
    MT1_MISC79,
    MT1_MISC80,
    MT1_MISC81,
    MT1_MISC82,
    MT1_MISC83,
    MT1_MISC84,
    MT1_MISC85,
    MT1_MISC86,

	NUMMOBJTYPES
};

// Ammunition types defined.
enum
{
    am_clip,	// Pistol / chaingun ammo.
    am_shell,	// Shotgun / double barreled shotgun.
    am_cell,	// Plasma rifle, BFG.
    am_misl,	// Missile launcher.
    NUMAMMO,
    am_noammo	// Unlimited for chainsaw / fist.
};

#define NUM_WEAPONS		9

enum
{
    sfx1_None,
    sfx1_pistol,
    sfx1_shotgn,
    sfx1_sgcock,
    sfx1_dshtgn,
    sfx1_dbopn,
    sfx1_dbcls,
    sfx1_dbload,
    sfx1_plasma,
    sfx1_bfg,
    sfx1_sawup,
    sfx1_sawidl,
    sfx1_sawful,
    sfx1_sawhit,
    sfx1_rlaunc,
    sfx1_rxplod,
    sfx1_firsht,
    sfx1_firxpl,
    sfx1_pstart,
    sfx1_pstop,
    sfx1_doropn,
    sfx1_dorcls,
    sfx1_stnmov,
    sfx1_swtchn,
    sfx1_swtchx,
    sfx1_plpain,
    sfx1_dmpain,
    sfx1_popain,
    sfx1_vipain,
    sfx1_mnpain,
    sfx1_pepain,
    sfx1_slop,
    sfx1_itemup,
    sfx1_wpnup,
    sfx1_oof,
    sfx1_telept,
    sfx1_posit1,
    sfx1_posit2,
    sfx1_posit3,
    sfx1_bgsit1,
    sfx1_bgsit2,
    sfx1_sgtsit,
    sfx1_cacsit,
    sfx1_brssit,
    sfx1_cybsit,
    sfx1_spisit,
    sfx1_bspsit,
    sfx1_kntsit,
    sfx1_vilsit,
    sfx1_mansit,
    sfx1_pesit,
    sfx1_sklatk,
    sfx1_sgtatk,
    sfx1_skepch,
    sfx1_vilatk,
    sfx1_claw,
    sfx1_skeswg,
    sfx1_pldeth,
    sfx1_pdiehi,
    sfx1_podth1,
    sfx1_podth2,
    sfx1_podth3,
    sfx1_bgdth1,
    sfx1_bgdth2,
    sfx1_sgtdth,
    sfx1_cacdth,
    sfx1_skldth,
    sfx1_brsdth,
    sfx1_cybdth,
    sfx1_spidth,
    sfx1_bspdth,
    sfx1_vildth,
    sfx1_kntdth,
    sfx1_pedth,
    sfx1_skedth,
    sfx1_posact,
    sfx1_bgact,
    sfx1_dmact,
    sfx1_bspact,
    sfx1_bspwlk,
    sfx1_vilact,
    sfx1_noway,
    sfx1_barexp,
    sfx1_punch,
    sfx1_hoof,
    sfx1_metal,
    sfx1_chgun,
    sfx1_tink,
    sfx1_bdopn,
    sfx1_bdcls,
    sfx1_itmbk,
    sfx1_flame,
    sfx1_flamst,
    sfx1_getpow,
    sfx1_bospit,
    sfx1_boscub,
    sfx1_bossit,
    sfx1_bospn,
    sfx1_bosdth,
    sfx1_manatk,
    sfx1_mandth,
    sfx1_sssit,
    sfx1_ssdth,
    sfx1_keenpn,
    sfx1_keendt,
    sfx1_skeact,
    sfx1_skesit,
    sfx1_skeatk,
    sfx1_radio,

	NUMSFX
};

//**************************************************************************
//
//	$Log: info.h,v $
//	Revision 1.1  2002/07/13 08:17:19  dj_jl
//	Removed all non-Doom stuff, since it's now used only for DeHackEd.
//	
//	Revision 1.4  2002/01/07 12:30:05  dj_jl
//	Changed copyright year
//	
//	Revision 1.3  2001/09/20 16:33:14  dj_jl
//	Beautification
//	
//	Revision 1.2  2001/07/27 14:27:55  dj_jl
//	Update with Id-s and Log-s, some fixes
//
//**************************************************************************
